#!/usr/bin/env node
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.deleteKey = exports.renameKey = exports.backupKey = exports.newKey = exports.switchKey = exports.getList = exports.getCurrent = exports.getDirectories = exports.SWITCH_FILE = exports.SSH_PATH = exports.HOME_PATH = void 0;
// import necessary files
var fs_1 = require("fs");
var os = __importStar(require("os"));
// import meow from 'meow'
var rmdir = __importStar(require("rimraf"));
var forge = __importStar(require("node-forge"));
var keypair_1 = __importDefault(require("keypair"));
var yargs_1 = __importDefault(require("yargs"));
var helpers_1 = require("yargs/helpers");
// Get path for work
exports.HOME_PATH = "".concat(os.homedir(), "/");
exports.SSH_PATH = "".concat(exports.HOME_PATH, ".ssh/");
exports.SWITCH_FILE = "".concat(exports.SSH_PATH, ".sshwitch");
// Get the all directory aka keys
var getDirectories = function (source) {
    var _a, _b;
    return (_b = (_a = (0, fs_1.readdirSync)(source, {
        withFileTypes: true,
    })) === null || _a === void 0 ? void 0 : _a.filter(function (dirent) { return dirent.isDirectory(); })) === null || _b === void 0 ? void 0 : _b.map(function (dirent) { return dirent.name; });
};
exports.getDirectories = getDirectories;
// Get current key
var getCurrent = function () {
    var _a;
    try {
        return (0, fs_1.readFileSync)(exports.SWITCH_FILE).toString();
    }
    catch (e) {
        (0, fs_1.writeFileSync)(exports.SWITCH_FILE, '');
        return (_a = (0, fs_1.readFileSync)(exports.SWITCH_FILE)) === null || _a === void 0 ? void 0 : _a.toString();
    }
};
exports.getCurrent = getCurrent;
// get all ssh keys
var getList = function () {
    var _a;
    (_a = (0, exports.getDirectories)(exports.SSH_PATH)) === null || _a === void 0 ? void 0 : _a.map(function (item) { return console.log(item); });
    return (0, exports.getDirectories)(exports.SSH_PATH);
};
exports.getList = getList;
// Switch ssh key
var switchKey = function (name) {
    try {
        if ((0, fs_1.existsSync)("".concat(exports.SSH_PATH + name, "/id_rsa")) &&
            (0, fs_1.existsSync)("".concat(exports.SSH_PATH + name, "/id_rsa.pub"))) {
            try {
                (0, fs_1.copyFileSync)("".concat(exports.SSH_PATH + name, "/id_rsa"), "".concat(exports.SSH_PATH, "id_rsa"));
                (0, fs_1.copyFileSync)("".concat(exports.SSH_PATH + name, "/id_rsa.pub"), "".concat(exports.SSH_PATH, "id_rsa.pub"));
                (0, fs_1.writeFileSync)(exports.SWITCH_FILE, name);
                (0, fs_1.chmodSync)("".concat(exports.SSH_PATH, "/id_rsa.pub"), 384);
                (0, fs_1.chmodSync)("".concat(exports.SSH_PATH, "/id_rsa"), 384);
                return console.log("Changed key pair to: ".concat(name));
            }
            catch (err) {
                console.log("Could not copy, check if you have permission to write on ".concat(exports.SSH_PATH));
                return console.error(err);
            }
        }
        else {
            console.log("Could not read key pair in ".concat(exports.SSH_PATH + name));
            console.log("Check if key pair exists in ".concat(exports.SSH_PATH + name, "\n\n"));
            console.log("If not you can create a new one with: \"sshmulti -n ".concat(name, "\""));
            return console.log("Or backup the current key pair in ".concat(exports.SSH_PATH, " with: \"sshmulti -b ").concat(name, "\""));
        }
    }
    catch (err) {
        return console.error(err);
    }
};
exports.switchKey = switchKey;
// Register new ssh key
var newKey = function (name) {
    if ((0, fs_1.existsSync)(exports.SSH_PATH + name)) {
        return console.log("".concat(exports.SSH_PATH + name, " already exists, skipping"));
    }
    console.log("Creating key pair in ".concat(exports.SSH_PATH + name));
    try {
        (0, fs_1.mkdirSync)(exports.SSH_PATH + name);
        var pair = (0, keypair_1.default)();
        var publicKey = forge.pki.publicKeyFromPem(pair.public);
        var privateKey = forge.pki.privateKeyFromPem(pair.private);
        var ssh = forge.ssh.publicKeyToOpenSSH(publicKey);
        var sshPrivate = forge.ssh.privateKeyToOpenSSH(privateKey);
        (0, fs_1.writeFileSync)("".concat(exports.SSH_PATH + name, "/id_rsa.pub"), ssh);
        (0, fs_1.writeFileSync)("".concat(exports.SSH_PATH + name, "/id_rsa"), sshPrivate);
        (0, fs_1.chmodSync)("".concat(exports.SSH_PATH + name, "/id_rsa.pub"), 384);
        (0, fs_1.chmodSync)("".concat(exports.SSH_PATH + name, "/id_rsa"), 384);
        return console.log("\n public key: \n\n ".concat(ssh, "\n private key: \n\n ").concat(sshPrivate));
    }
    catch (err) {
        console.log("Could not create key pair, check if you have permission to write on ".concat(exports.SSH_PATH + name));
        return console.log(err);
    }
};
exports.newKey = newKey;
// backup ssh keys
var backupKey = function (name) {
    if ((0, fs_1.existsSync)(exports.SSH_PATH + name)) {
        return console.log("".concat(exports.SSH_PATH + name, " already exists, skipping"));
    }
    console.log("Copying current key pair in ".concat(exports.SSH_PATH, " to ").concat(exports.SSH_PATH + name));
    try {
        (0, fs_1.mkdirSync)(exports.SSH_PATH + name);
        (0, fs_1.copyFileSync)("".concat(exports.SSH_PATH, "id_rsa"), "".concat(exports.SSH_PATH + name, "/id_rsa"));
        (0, fs_1.copyFileSync)("".concat(exports.SSH_PATH, "id_rsa.pub"), "".concat(exports.SSH_PATH + name, "/id_rsa.pub"));
        return console.log("Backup to current key pair in ".concat(exports.SSH_PATH, " to ").concat(exports.SSH_PATH + name));
    }
    catch (err) {
        console.log("Could not backup key pair, check if you have permission to write on ".concat(exports.SSH_PATH + name));
        return console.log(err);
    }
};
exports.backupKey = backupKey;
// Rename ssh key
var renameKey = function (oldName, newName) {
    if (!(0, fs_1.existsSync)(exports.SSH_PATH + oldName)) {
        return console.log("".concat(exports.SSH_PATH + oldName, " doesn't exists, cannot rename"));
    }
    if ((0, fs_1.existsSync)(exports.SSH_PATH + newName)) {
        return console.log("".concat(exports.SSH_PATH + newName, " already exists, cannot rename"));
    }
    try {
        (0, fs_1.renameSync)(exports.SSH_PATH + oldName, exports.SSH_PATH + newName);
        if ((0, exports.getCurrent)() === oldName) {
            (0, fs_1.writeFileSync)(exports.SWITCH_FILE, newName);
            (0, exports.switchKey)(newName);
        }
        return console.log('Renamed the current key');
    }
    catch (err) {
        console.log('Could not rename');
        return console.log(err);
    }
};
exports.renameKey = renameKey;
// delete ssh key
var deleteKey = function (name) {
    try {
        rmdir.sync(exports.SSH_PATH + name);
        return console.log("Deleted ".concat(name, " sshkey."));
    }
    catch (e) {
        return console.log(e);
    }
};
exports.deleteKey = deleteKey;
// Using argv for taking flag and input
var argv = (0, yargs_1.default)((0, helpers_1.hideBin)(process.argv))
    .usage("\n    Switch and manage key pairs in ".concat(exports.SSH_PATH, "\n    Default usage: sshmulti key_pair_name\n    Advanced usage: sshmulti [option]\n    -c, --current                    Get name of current key pair\n    -n, --new                        New key pair name\n    -b, --backup                     Backup key pair in ").concat(exports.SSH_PATH, "\n    -r, --rename                     Rename a key pair\n    -l, --list                       Get list of key pairs in ").concat(exports.SSH_PATH, "\n    -d, --delete DELETE              Delete key pair\n    "))
    .help('help')
    .alias('help', 'h')
    .version('version', '3.0.1')
    .alias('version', 'V')
    .options({
    backup: { type: 'boolean', alias: ['backup', 'b'], default: false },
    new: { type: 'boolean', alias: ['new', 'n'], default: false },
    rename: { type: 'boolean', alias: ['rename', 'r'], default: false },
    list: { type: 'boolean', alias: ['list', 'l'], default: false },
    current: { type: 'boolean', alias: ['current', 'c'], default: false },
    delete: { type: 'boolean', alias: ['delete', 'd'], default: false },
})
    .parseSync();
// Let the fun began
var isBackup = argv.backup;
var isCurrent = argv.current;
var isDelete = argv.delete;
var isList = argv.list;
var isRename = argv.rename;
var isNew = argv.new;
var name = argv._ || '';
switch (true) {
    case isBackup && ((_a = name[0].toString()) === null || _a === void 0 ? void 0 : _a.length) === 1:
        (0, exports.backupKey)(name[0].toString());
        break;
    case isRename && name.length === 2:
        // eslint-disable-next-line no-case-declarations
        if (name[0] && name[1]) {
            (0, exports.renameKey)(name[0].toString(), name[1].toString());
        }
        else {
            console.log('Please enter valid name. Type sshmulti --help for more.');
        }
        break;
    case isNew && name.length === 1:
        (0, exports.newKey)(name[0].toString());
        break;
    case isDelete && name.length === 1:
        (0, exports.deleteKey)(name[0].toString());
        break;
    case isList:
        (0, exports.getList)();
        break;
    case isCurrent || name.length === 0:
        console.log((0, exports.getCurrent)());
        break;
    case !isBackup &&
        !isCurrent &&
        !isDelete &&
        !isList &&
        !isRename &&
        !isNew &&
        name.length === 1:
        (0, exports.switchKey)(name[0].toString());
        break;
    case name.length > 1:
        console.log('Enter sshmulti --help for more command');
        break;
    default:
        console.log((0, exports.getCurrent)());
        break;
}
exports.default = exports.getDirectories;
